unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Types, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    Panel1: TPanel;
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    FPanelMoving: Boolean;
    FPanelOrig: TPoint;
    FMouseOrig: TPoint;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FPanelOrig := Point(Panel1.Left, Panel1.Top);
  GetCursorPos(FMouseOrig);
  FPanelMoving := True;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  MouseOffset: TPoint;
begin
  if not FPanelMoving then Exit;
  GetCursorPos(MouseOffset);
  MouseOffset := MouseOffset - FMouseOrig;
  Panel1.SetBounds(FPanelOrig.X + MouseOffset.X,
                   FPanelOrig.Y + MouseOffset.Y,
                   Panel1.Width,
                   Panel1.Height);
end;

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FPanelMoving := False;
end;

end.

